<template>
  <el-dialog title="权限管理" :visible.sync="isVisible" @open="fetchData" @close="onClose()">
    <div>
      <div v-if="canAdd" class="toolbar-container">
        <el-button class="toolbar-item" style="" type="primary" icon="el-icon-edit" @click="addPerm">
          添加权限
        </el-button>
      </div>
      <el-table
        v-loading="listLoading"
        :data="permlist"
        element-loading-text="Loading"
        border
        fit
        highlight-current-row
      >
        <el-table-column label="用户名">
          <template slot-scope="scope">
            {{ scope.row.username }}
          </template>
        </el-table-column>
        <el-table-column label="应用节点">
          <template slot-scope="scope">
            {{ scope.row.nodepath }} ( {{ scope.row.nodeid }} )
          </template>
        </el-table-column>
        <el-table-column label="权限类型">
          <template slot-scope="scope">
            {{ scope.row.permission }}
          </template>
        </el-table-column>
        <el-table-column fixed="right" label="操作" width="110" align="center">
          <template slot-scope="scope">
            <el-button @click="delPerm(scope.row)" type="text" size="small">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <el-dialog title="添加权限" :visible.sync="dialogFormVisible">
        <el-form ref="dataForm" :model="temp" label-position="left" label-width="70px"
                 style="width: 400px; margin-left:50px;">
          <el-form-item label="用户名" prop="title">
            <el-input v-model="temp.user"/>
          </el-form-item>
          <el-form-item label="应用节点">
            <el-input v-model="temp.nodeid" :disabled="true"/>
          </el-form-item>
          <el-form-item label="权限类型">
            <el-select v-model="temp.permtype" placeholder="请选择权限类型">
              <el-option label="允许（允许当前节点及所有子节点访问）" value="allow"/>
              <el-option label="拒绝（拒绝当前节点及所有子节点访问）" value="deny"/>
            </el-select>
          </el-form-item>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button @click="dialogFormVisible = false">
            取消
          </el-button>
          <el-button type="primary" @click="handleAddPerm()">
            确认
          </el-button>
        </div>
      </el-dialog>
    </div>
  </el-dialog>

</template>

<script>
    import {list_permission, add_permission, remove_permission} from '@/api/permission'

    export default {
        name: "index.vue",
        props: ['canAdd', 'dialogData'],
        data() {
            return {
                permlist: null,
                listLoading: false,
                isVisible: false,
                dialogFormVisible: false,
                //curUser: undefined,
                //curNode: undefined,
                temp: {
                    user: null,
                    nodeid: null,
                    permtype: null,
                }
            }
        },
        created() {
            this.$on('open', function(){
                this.isVisible = true
            });
            this.fetchData()
        },
        methods: {
            onClose() {
                if (this.isVisible)
                  this.$emit('update:isVisible', false)
            },
            fetchData() {
                if (this.dialogData.curUser !== undefined && this.dialogData.curNode !== undefined) {
                    this.listLoading = true
                    list_permission(this.dialogData.curUser, this.dialogData.curNode, null).then(response => {
                        this.permlist = response.content
                        this.listLoading = false
                    })
                }
            },
            /*updatePara(curUser, curNode) {
                this.curUser = curUser
                this.curNode = curNode
                this.fetchData()
            },*/
            addPerm() {
                if (this.dialogData.curNode === undefined) {
                    return
                }
                this.temp = {
                    user: undefined,
                    nodeid: undefined,
                    permtype: undefined,
                }
                this.temp.nodeid = this.dialogData.curNode
                this.dialogFormVisible = true
            },
            handleAddPerm() {
                add_permission(this.temp.user, this.temp.nodeid, this.temp.permtype).then(() => {
                    this.dialogFormVisible = false
                    this.$notify({
                        title: '成功',
                        message: '权限添加成功',
                        type: 'success',
                        duration: 2000
                    })
                    this.fetchData()
                })

            },
            delPerm(row) {
                remove_permission(row.username, row.nodeid, null).then(() => {
                    this.$notify({
                        title: '成功',
                        message: '权限删除成功',
                        type: 'success',
                        duration: 2000
                    })
                    this.fetchData()
                })
            }
        }
    }
</script>

<style scoped>

</style>